package org.tonylin.util.exec;

import java.util.List;

public class CompositeRetryablePolicy implements IRetryablePolicy {

	private List<IRetryablePolicy> mPolicyList = null;
	
	public CompositeRetryablePolicy(){
		
	}
	
	public CompositeRetryablePolicy(List<IRetryablePolicy> policyList){
		mPolicyList = policyList;
	}
	
	@Override
	public boolean needToRetry(Object data) {
		if( mPolicyList == null ){
			return false;
		}
		boolean needRetry = !mPolicyList.isEmpty();
		for( IRetryablePolicy policy : mPolicyList ){
			if(!policy.needToRetry(data)){
				needRetry = false;
			}
		}
		return needRetry;
	}
}
