package org.tonylin.util.exec;
import java.util.ArrayList;
import java.util.List;

public class ExceptionRetryablePolicy implements IRetryablePolicy {

	private List<Class<? extends Throwable>> mExceptinList = null;
	
	public ExceptionRetryablePolicy() {
		this(Exception.class);
	}
	
	public ExceptionRetryablePolicy(Class<? extends Throwable> throwableClass) {
		mExceptinList = new ArrayList<Class<? extends Throwable>>();
		mExceptinList.add(throwableClass);
	}
	
	public ExceptionRetryablePolicy(List<Class<? extends Throwable>> exceptinList) {
		mExceptinList = exceptinList;
	}
	
	@Override
	public boolean needToRetry(Object data) {
		if( data == null || mExceptinList == null )
			return false;
		for( Class<? extends Throwable> throwableClass : mExceptinList ){
			if( throwableClass.isInstance(data)){
				return true;
			}
		}
		return false;
	}
}
