package org.tonylin.util.exec;

public class VariableSleepStrategy implements ISleepStrategy {

	private int mCurrentIndex = 0;
	private long[] mSleepTimes;
	private int mMaxLenghth = 0;
	
	public VariableSleepStrategy(long[] sleepTimes){
		mMaxLenghth = sleepTimes.length;
		mSleepTimes = new long[mMaxLenghth];
		System.arraycopy(sleepTimes, 0, mSleepTimes, 0, mMaxLenghth);
	}
	
	@Override
	public long getSleepTime() {
		if( mCurrentIndex == mMaxLenghth ){
			throw new RuntimeException("Over the max length.");
		}
		return mSleepTimes[mCurrentIndex++];
	}
}
